
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>15、 Heartbeat+DRBD+MySQL高可用架构方案与实施过程细节 / 憋错料</title>

    <meta name="description" content="15、 Heartbeat+DRBD+MySQL高可用架构方案与实施过程细节 15. Heartbeat+DRBD+MySQL高可用架构方案与实施过程细节 参考自:http://oldboy.blog.51cto.com/2561410/1240412 heartbeat和keepalived应用场景及区别 很多网友说为什么不使用keepalived而使用长期不更新的heartbeat,下面说一下它们之间的应用场景及区别: 1.对于web,db,负载均衡(lvs,haproxy,nginx)等,heartbeat和keepalived都可以实现 2.lvs最好和keepa">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">15、 Heartbeat+DRBD+MySQL高可用架构方案与实施过程细节</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>15、 <strong>Heartbeat+DRBD+MySQL</strong>高可用架构方案与实施过程细节</p>
<p>参考自：<a href="http://oldboy.blog.51cto.com/2561410/1240412" rel="external nofollow noreferrer">http://oldboy.blog.51cto.com/2561410/1240412</a></p>
<table>
<tbody>
<tr>
<td>
<br />heartbeat和keepalived应用场景及区别</p>
</td>
<td>
<br />很多网友说为什么不使用keepalived而使用长期不更新的heartbeat，下面说一下它们之间的应用场景及区别：</p>
<p>1、对于web，db，负载均衡(lvs,haproxy,nginx)等，heartbeat和keepalived都可以实现</p>
<p>2、lvs最好和keepalived结合，因为keepalived最初就是为lvs产生的，(heartbeat没有对RS的健康检查功能，heartbeat可以通过ldircetord来进行健康检查的功能)</p>
<p>3、mysql双主多从，NFS/MFS存储，他们的特点是需要数据同步，这样的业务最好使用heartbeat，因为heartbeat有自带的drbd脚本</p>
<p><strong>总结：</strong></p>
<p><strong>无数据同步</strong>的应用程序高可用可选择<strong>keepalived</strong>，</p>
<p><strong>有数据同步</strong>的应用程序高可用可选择<strong>heartbeat（DRBD）</strong> 。</p>
</td>
</tr>
<tr>
<td>
<br />1、</p>
<p>安装部署准备</p>
</td>
<td>
<br />（1）架构拓扑</p>
<p><img src="/e/u261/themes/default/images/spacer.gif" /></p>
<p>架构说明：</p>
<p>一主多从最常用的架构，多个从库可以使用lvs来提供读的负载均衡。</p>
<p>解决一主单点的问题，当主库宕机后，可以实现主库宕机后备节点自动接管，所有的从库会自动和新的主库进行同步，实现了mysql主库的热备方案</p>
<p>（2）系统环境：</p>
<p><img src="/e/u261/themes/default/images/spacer.gif" /></p>
<p>（3）部署环境</p>
<p><img src="/e/u261/themes/default/images/spacer.gif" /></p>
<p>（4）主库服务器数据分区信息</p>
<p><img src="/e/u261/themes/default/images/spacer.gif" /></p>
</td>
</tr>
<tr>
<td>
<br />2、heatbeat安装部署</p>
</td>
<td>
<br />(1)、配置服务器间心跳连接路由</p>
<p>主节点</p>
<p>[[email&#160;protected] ~]# route add -host 172.16.4.3 dev eth2&lt;==到对端的心跳路由</p>
<p>[[email&#160;protected] ~]# route add -host 172.168.4.3 dev eth3&lt;==到对端的DRBD数据路由</p>
<p>备节点</p>
<p>[[email&#160;protected] ~]# route add -host 172.16.4.2 dev eth2</p>
<p>[[email&#160;protected] ~]# route add -host 172.168.4.2 dev eth3</p>
<p>(2)、安装heartbeat</p>
<p>[[email&#160;protected] ~]# yum install heartbeat -y</p>
<p>[[email&#160;protected] ~]# yum install heartbeat -y</p>
<p>提示：需要执行两遍安装heartbeat操作</p>
<p>(3)、配置heartbeat</p>
<p>主备节点两端的配置文件(ha.cfauthkeysharesources)完全相同</p>
<p>1)、ha.cf</p>
<p>[[email&#160;protected] ~]# vim /etc/ha.d/ha.cf</p>
<p>#log configure</p>
<p>debugfile /var/log/ha-debug</p>
<p>logfile /var/log/ha-log</p>
<p>logfacility local1</p>
<p>#options configure</p>
<p>keepalive 2</p>
<p>deadtime 30</p>
<p>warntime 10</p>
<p>initdead 120</p>
<p>#bcast eth2</p>
<p>mcast eth2 225.0.0.7 694 1 0</p>
<p>#node configure</p>
<p>auto_failback on</p>
<p>node master1 &lt;==主节点主机名</p>
<p>node master2 &lt;==备节点主机名</p>
<p>crm no</p>
<p>2)、配置authkeys</p>
<p>[[email&#160;protected] ~]# vim /etc/ha.d/authkeys</p>
<p>auth 1</p>
<p>1 sha1 47e9336850f1db6fa58bc470bc9b7810eb397f04</p>
<p>3)、配置haresources</p>
<p>[[email&#160;protected] ~]# vim /etc/ha.d/haresources</p>
<p>master1 IPaddr::192.168.4.1/16/eth1</p>
<p>#master1 IPaddr::192.168.4.1/16/eth1 drbddisk::data Filesystem::/dev/drbd1::/data::ext3 mysqld</p>
<p>说明：</p>
<p>drbddisk::data &lt;==启动drbd data资源，相当于执行/etc/ha.d/resource.d/drbddisk data stop/start操作</p>
<p>Filesystem::/dev/drbd1::/data::ext3 &lt;==drbd分区挂载到/data目录，相当于执行/etc/ha.d/resource.d/Filesystem /dev/drbd1 /data ext3 stop/start &lt;==相当于系统中执行mount /dev/drbd1 /data</p>
<p>mysql &lt;==启动mysql服务脚本，相当于/etc/init.d/mysql stop/start</p>
<p>(4)、启动heartbeat</p>
<p>[[email&#160;protected] ~]# /etc/init.d/heartbeat start</p>
<p>[[email&#160;protected] ~]# chkconfig heartbeat off</p>
<p>说明：关闭开机自启动，当服务器重启时，需要人工去启动</p>
<p>(5)、测试heartbeat</p>
<p>正常状态</p>
<p>[[email&#160;protected]master1 ~]# ip addr|grep eth1</p>
<p>3: eth1: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc pfifo_fast qlen 1000</p>
<p>inet 192.168.4.2/16 brd 192.168.255.255 scope global eth1</p>
<p>inet 192.168.4.1/16 brd 192.168.255.255 scope global secondary eth1:0</p>
<p>[[email&#160;protected] ~]# ip addr|grep eth1</p>
<p>3: eth1: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc pfifo_fast qlen 1000</p>
<p>inet 192.168.4.3/16 brd 192.168.255.255 scope global eth1</p>
<p>说明：master1节点拥有vip地址，master2节点没有</p>
<p>模拟主节点宕机后的状态</p>
<p>[[email&#160;protected] ~]# /etc/init.d/heartbeat stop</p>
<p>[[email&#160;protected]master2 ~]# ip addr|grep eth1</p>
<p>3: eth1: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc pfifo_fast qlen 1000</p>
<p>inet 192.168.4.3/16 brd 192.168.255.255 scope global eth1</p>
<p>inet 192.168.4.1/16 brd 192.168.255.255 scope global secondary eth1:0</p>
<p>说明：master1宕机后，vip地址漂移到master2节点上，master2成为主节点</p>
<p>模拟主节点故障恢复后的状态</p>
<p>[[email&#160;protected] ~]# /etc/init.d/heartbeat start</p>
<p>[[email&#160;protected]master1 ~]# ip addr|grep eth1</p>
<p>3: eth1: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc pfifo_fast qlen 1000</p>
<p>inet 192.168.4.2/16 brd 192.168.255.255 scope global eth1</p>
<p>inet 192.168.4.1/16 brd 192.168.255.255 scope global secondary eth1:0</p>
<p>说明：master1抢占vip资源</p>
</td>
</tr>
<tr>
<td>
<br />3、DRBD</p>
<p>安装部署</p>
</td>
<td>
<br />(1)、新添加硬盘</p>
<p>[[email&#160;protected] ~]# fdisk /dev/sdb &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; #sdb磁盘分两个分区sdb1和sdb2</p>
<p>[[email&#160;protected] ~]# partprobe</p>
<p>[[email&#160;protected] ~]# mkfs.ext3 /dev/sdb1 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;#sdb2分区为meta data分区，不需要格式化操作</p>
<p>[[email&#160;protected] ~]# tune2fs -c -1 /dev/sdb1 &nbsp; &nbsp;&nbsp; #设置最大挂载数为-1</p>
<p>(2)、安装DRBD</p>
<p>[[email&#160;protected] ~]# yum install kmod-drbd83 drbd83 -y</p>
<p>[[email&#160;protected] ~]# modprobe drbd</p>
<p>#注意：不要设置echo ‘modprobe drbd‘ &gt;&gt;/etc/rc.loca开机自动加载drbd模块，如果drbd服务是开机自启动的，会先启动drbd服务在加载drbd的顺序，导致drbd启动不了出现的问题</p>
<p>(3)、配置DRBD</p>
<p>主备节点两端配置文件完全一致</p>
<p>[[email&#160;protected] ~]# cat /etc/drbd.conf</p>
<p>global {</p>
<p># minor-count 64;</p>
<p># dialog-refresh 5; # 5 seconds</p>
<p># disable-ip-verification;</p>
<p>usage-count no;</p>
<p>}</p>
<p>common {</p>
<p>protocol C;</p>
<p>disk {</p>
<p>on-io-error&nbsp;&nbsp; detach;</p>
<p>#size 454G;</p>
<p>no-disk-flushes;</p>
<p>no-md-flushes;</p>
<p>}</p>
<p>net {</p>
<p>sndbuf-size 512k;</p>
<p># timeout&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 60;&nbsp;&nbsp;&nbsp; #&nbsp; 6 seconds&nbsp; (unit = 0.1 seconds)</p>
<p># connect-int&nbsp;&nbsp; 10;&nbsp;&nbsp;&nbsp; # 10 seconds&nbsp; (unit = 1 second)</p>
<p># ping-int&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 10;&nbsp;&nbsp;&nbsp; # 10 seconds&nbsp; (unit = 1 second)</p>
<p># ping-timeout&nbsp;&nbsp; 5;&nbsp;&nbsp;&nbsp; # 500 ms (unit = 0.1 seconds)</p>
<p>max-buffers&nbsp;&nbsp;&nbsp;&nbsp; 8000;</p>
<p>unplug-watermark&nbsp;&nbsp; 1024;</p>
<p>max-epoch-size&nbsp; 8000;</p>
<p># ko-count 4;</p>
<p># allow-two-primaries;</p>
<p>cram-hmac-alg "sha1";</p>
<p>shared-secret "hdhwXes23sYEhart8t";</p>
<p>after-sb-0pri disconnect;</p>
<p>after-sb-1pri disconnect;</p>
<p>after-sb-2pri disconnect;</p>
<p>rr-conflict disconnect;</p>
<p># data-integrity-alg "md5";</p>
<p># no-tcp-cork;</p>
<p>}</p>
<p>syncer {</p>
<p>rate 120M;</p>
<p>al-extents 517;</p>
<p>}</p>
<p>}</p>
<p>resource data {</p>
<p>on master1 {</p>
<p>device&nbsp;&nbsp;&nbsp;&nbsp; /dev/drbd1;</p>
<p>disk&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /dev/sdb1;</p>
<p>address&nbsp;&nbsp;&nbsp; 192.168.4.2:7788;</p>
<p>meta-disk&nbsp; /dev/sdb2 [0];</p>
<p>}</p>
<p>on master2 {</p>
<p>device&nbsp;&nbsp;&nbsp;&nbsp; /dev/drbd1;</p>
<p>disk&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /dev/sdb1;</p>
<p>address&nbsp;&nbsp;&nbsp; 192.168.4.3:7788;</p>
<p>meta-disk&nbsp; /dev/sdb2 [0];</p>
<p>}</p>
<p>}</p>
<p>(4)、初始化meta分区</p>
<p>[[email&#160;protected] ~]# drbdadm create-md data</p>
<p>Writing meta data...</p>
<p>initializing activity log</p>
<p>NOT initialized bitmap</p>
<p>New drbd meta data block successfully created.</p>
<p>(5)、初始化设备同步(覆盖备节点，保持数据一致)</p>
<p>[[email&#160;protected] ~]# drbdadm -- --overwrite-data-of-peer primary data</p>
<p>(6)、启动drbd</p>
<p>[[email&#160;protected] ~]# drbdadm up all</p>
<p>[[email&#160;protected] ~]# chkconfig drbd off</p>
<p>(7)、挂载drbd分区到data数据目录</p>
<p>[[email&#160;protected] ~]# drbdadm primary all</p>
<p>[[email&#160;protected] ~]# mount /dev/drbd1 /data &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;#说明：/data目录为数据库的数据目录</p>
<p>(8)、测试DRBD</p>
<p>正常状态</p>
<p>[[email&#160;protected] ~]# cat /proc/drbd</p>
<p>version: 8.3.13 (api:88/proto:86-96)</p>
<p>GIT-hash: 83ca112086600faacab2f157bc5a9324f7bd7f77 build by [email&#160;protected], 2012-05-07 11:56:36</p>
<p>1: cs:Connected ro:Primary/Secondary ds:UpToDate/UpToDate C r-----</p>
<p>ns:497984 nr:0 dw:1 dr:498116 al:1 bm:31 lo:0 pe:0 ua:0 ap:0 ep:1 wo:b oos:0</p>
<p>[[email&#160;protected] ~]# cat /proc/drbd</p>
<p>version: 8.3.13 (api:88/proto:86-96)</p>
<p>GIT-hash: 83ca112086600faacab2f157bc5a9324f7bd7f77 build by [email&#160;protected], 2012-05-07 11:56:36</p>
<p>1: cs:Connected ro:Secondary/Primary ds:UpToDate/UpToDate C r-----</p>
<p>ns:0 nr:497984 dw:497984 dr:0 al:0 bm:30 lo:0 pe:0 ua:0 ap:0 ep:1 wo:b oos:0</p>
<p>#说明：master1为主节点，master2为备节点</p>
<p>模拟master1宕机</p>
<p>[[email&#160;protected] ~]# umount /dev/drbd1</p>
<p>[[email&#160;protected] ~]# drbdadm down all</p>
<p>[[email&#160;protected] ~]# cat /proc/drbd</p>
<p>version: 8.3.13 (api:88/proto:86-96)</p>
<p>GIT-hash: 83ca112086600faacab2f157bc5a9324f7bd7f77 build by [email&#160;protected], 2012-05-07 11:56:36</p>
<p>1: cs:WFConnection ro:Secondary/Unknown ds:UpToDate/DUnknown C r-----</p>
<p>ns:0 nr:497985 dw:497985 dr:0 al:0 bm:30 lo:0 pe:0 ua:0 ap:0 ep:1 wo:b oos:0</p>
<p>[[email&#160;protected] ~]# drbdadm primary all</p>
<p>[[email&#160;protected] ~]# mount /dev/drbd1 /data</p>
<p>[[email&#160;protected] ~]# df -h</p>
<p>Filesystem Size Used Avail Use% Mounted on</p>
<p>/dev/sda3 19G 5.1G 13G 29% /</p>
<p>/dev/sda1 190M 18M 163M 10% /boot</p>
<p>tmpfs 60M 0 60M 0% /dev/shm</p>
<p>/dev/drbd1 471M 11M 437M 3% /data</p>
<p>#说明：master1宕机后，master2可以升级为主节点，可挂载drbd分区继续使用</p>
</td>
</tr>
<tr>
<td>
<br />4、MySQL</p>
<p>安装部署</p>
</td>
<td>
<br />注意：三台数据库都安装mysql服务，master2只安装到makeinstall即可，mysqld服务不要设置为开机自启动</p>
<p>(1)、解决perl编译问题</p>
<p>echo ‘export LC_ALL=C‘&gt;&gt; /etc/profile</p>
<p>source /etc/profile</p>
<p>(2)、安装CAMKE</p>
<p>cd /home/xu/tools</p>
<p>wget http://www.cmake.org/files/v2.8/cmake-2.8.4.tar.gz</p>
<p>tar zxf cmake-2.8.4.tar.gz</p>
<p>cd cmake-2.8.4</p>
<p>./configure</p>
<p>make &amp; make install</p>
<p>(3)、创建用户</p>
<p>groupadd mysql</p>
<p>useradd -g mysql mysql</p>
<p>(4)、编译安装mysql</p>
<p>wget http://mysql.ntu.edu.tw/Downloads/MySQL-5.5/mysql-5.5.27.tar.gz</p>
<p>tar zxf mysql-5.5.27.tar.gz</p>
<p>cd mysql-5.5.27</p>
<p>cmake -DCMAKE_INSTALL_PREFIX=/usr/local/mysql \</p>
<p>-DMYSQL_UNIX_ADDR=/tmp/mysql.sock \</p>
<p>-DDEFAULT_CHARSET=utf8 \</p>
<p>-DDEFAULT_COLLATION=utf8_general_ci \</p>
<p>-DWITH_EXTRA_CHARSETS=complex \</p>
<p>-DWITH_READLINE=1 \</p>
<p>-DENABLED_LOCAL_INFILE=1</p>
<p>make -j 4</p>
<p>make install</p>
<p>(5)、设置mysql环境变量</p>
<p>[[email&#160;protected] ~]# echo ‘PATH=$PATH:/usr/local/mysql/bin‘ &gt;&gt;/etc/profile</p>
<p>[[email&#160;protected] ~]# source /etc/profile</p>
<p>(6)、初始化数据库</p>
<p>[[email&#160;protected] ~]# mount /dev/drbd1 /data &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; #说明：数据库存放数据的目录是drbd分区</p>
<p>[[email&#160;protected] ~]# cd /usr/local/mysql/</p>
<p>[[email&#160;protected] ~]# ./scripts/mysql_install_db --datadir=/data/ --user=mysql</p>
<p>(7)、启动数据库</p>
<p>[[email&#160;protected] ~]# vim /etc/init.d/mysqld</p>
<p>datadir=/data &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp; #说明：修改mysql启动脚本，指定数据库的目录为/data</p>
<p>[[email&#160;protected] ~]# /etc/init.d/mysqld start</p>
<p>[[email&#160;protected] ~]# chkconfig mysqld off</p>
<p>(8)、测试数据库</p>
<p>[[email&#160;protected] ~]# mysql -uroot -e "show databases;"</p>
<p>+--------------------+</p>
<p>| Database |</p>
<p>+--------------------+</p>
<p>| information_schema |</p>
<p>| mysql |</p>
<p>| performance_schema |</p>
<p>+--------------------+</p>
</td>
</tr>
<tr>
<td>
<br />5、故障切换测试</p>
</td>
<td>
<br />(1)、架构正常状态</p>
<p>master1主节点正常状态</p>
<p>[[email&#160;protected] ~]# ip addr|grep eth1</p>
<p>3: eth1: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc pfifo_fast qlen 1000</p>
<p>inet 192.168.4.2/16 brd 192.168.255.255 scope global eth1</p>
<p>inet 192.168.4.1/16 brd 192.168.255.255 scope global secondary eth1:0</p>
<p>[[email&#160;protected] ~]# cat /proc/drbd</p>
<p>version: 8.3.13 (api:88/proto:86-96)</p>
<p>GIT-hash: 83ca112086600faacab2f157bc5a9324f7bd7f77 build by [email&#160;protected], 2012-05-07 11:56:36</p>
<p>1: cs:Connected ro:Primary/Secondary ds:UpToDate/UpToDate C r-----</p>
<p>ns:39558 nr:12 dw:39570 dr:151 al:16 bm:1 lo:0 pe:0 ua:0 ap:0 ep:1 wo:b oos:0</p>
<p>[[email&#160;protected] ~]# mysql -uroot -e "create database coral;"</p>
<p>[[email&#160;protected] ~]# mysql -uroot -e "show databases like ‘coral‘;"</p>
<p>+------------------+</p>
<p>| Database (coral) |</p>
<p>+------------------+</p>
<p>| coral |</p>
<p>+------------------+</p>
<p>#说明：master1为主节点，拥有VIP地址，为drbd的主节点</p>
<p>master2备节点正常状态</p>
<p>[[email&#160;protected] ~]# ip addr|grep eth1</p>
<p>3: eth1: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc pfifo_fast qlen 1000</p>
<p>inet 192.168.4.3/16 brd 192.168.255.255 scope global eth1</p>
<p>[[email&#160;protected] ~]# cat /proc/drbd</p>
<p>version: 8.3.13 (api:88/proto:86-96)</p>
<p>GIT-hash: 83ca112086600faacab2f157bc5a9324f7bd7f77 build by [email&#160;protected], 2012-05-07 11:56:36</p>
<p>1: cs:Connected ro:Secondary/Primary ds:UpToDate/UpToDate C r-----</p>
<p>ns:0 nr:48 dw:48 dr:0 al:0 bm:0 lo:0 pe:0 ua:0 ap:0 ep:1 wo:b oos:0</p>
<p>#说明：master2备节点没有VIP地址，为drbd备节点</p>
<p>(2)、模拟master1宕机故障状态</p>
<p>[[email&#160;protected] ~]# /etc/init.d/heartbeat stop &lt;==模拟master1故障宕机</p>
<p>[[email&#160;protected] ~]# tailf /var/log/ha-log &lt;==查看备节点接管日志</p>
<p>heartbeat[13209]: 2013/01/23_04:09:36 info: Received shutdown notice from ‘master1‘.</p>
<p>heartbeat[13209]: 2013/01/23_04:09:36 info: Resources being acquired from master1.</p>
<p>heartbeat[15293]: 2013/01/23_04:09:36 info: acquire local HA resources (standby).</p>
<p>heartbeat[15294]: 2013/01/23_04:09:37 info: No local resources [/usr/share/heartbeat/ResourceManager listkeys master2] to acquire.</p>
<p>heartbeat[15293]: 2013/01/23_04:09:37 info: local HA resource acquisition completed (standby).</p>
<p>heartbeat[13209]: 2013/01/23_04:09:37 info: Standby resource acquisition done [foreign].</p>
<p>harc[15319]: 2013/01/23_04:09:37 info: Running /etc/ha.d/rc.d/status status</p>
<p>mach_down[15335]: 2013/01/23_04:09:37 info: Taking over resource group IPaddr::192.168.4.1/16/eth1</p>
<p>ResourceManager[15361]: 2013/01/23_04:09:37 info: Acquiring resource group: master1 IPaddr::192.168.4.1/16/eth1 drbddisk::data Filesystem::/dev/drbd1::/data::ext3 mysqld</p>
<p>IPaddr[15388]: 2013/01/23_04:09:37 INFO: Resource is stopped</p>
<p>ResourceManager[15361]: 2013/01/23_04:09:37 info: Running /etc/ha.d/resource.d/IPaddr 192.168.4.1/16/eth1 start</p>
<p>IPaddr[15486]: 2013/01/23_04:09:38 INFO: Using calculated netmask for 192.168.4.1: 255.255.0.0</p>
<p>IPaddr[15486]: 2013/01/23_04:09:38 INFO: eval ifconfig eth1:0 192.168.4.1 netmask 255.255.0.0 broadcast 192.168.255.255</p>
<p>IPaddr[15457]: 2013/01/23_04:09:38 INFO: Success</p>
<p>ResourceManager[15361]: 2013/01/23_04:09:38 info: Running /etc/ha.d/resource.d/drbddisk data start</p>
<p>Filesystem[15636]: 2013/01/23_04:09:39 INFO: Resource is stopped</p>
<p>ResourceManager[15361]: 2013/01/23_04:09:39 info: Running /etc/ha.d/resource.d/Filesystem /dev/drbd1 /data ext3 start</p>
<p>Filesystem[15717]: 2013/01/23_04:09:39 INFO: Running start for /dev/drbd1 on /data</p>
<p>Filesystem[15706]: 2013/01/23_04:09:39 INFO: Success</p>
<p>ResourceManager[15361]: 2013/01/23_04:09:40 info: Running /etc/init.d/mysqld start</p>
<p>mach_down[15335]: 2013/01/23_04:09:44 info: /usr/share/heartbeat/mach_down: nice_failback: foreign resources acquired</p>
<p>mach_down[15335]: 2013/01/23_04:09:44 info: mach_down takeover complete for node master1.</p>
<p>heartbeat[13209]: 2013/01/23_04:09:44 info: mach_down takeover complete.</p>
<p>heartbeat[13209]: 2013/01/23_04:10:09 WARN: node master1: is dead</p>
<p>heartbeat[13209]: 2013/01/23_04:10:09 info: Dead node master1 gave up resources.</p>
<p>heartbeat[13209]: 2013/01/23_04:10:09 info: Link master1:eth2 dead.</p>
<p>#说明：当备节点无法检测到主节点的心跳时，自动接管资源，启动VIP地址、drbd服务，自动挂载drbd，启动mysqld服务，备节点接管后，数据依然存在，检测启动的服务如下：</p>
<p>[[email&#160;protected] ~]# ip addr|grep eth1</p>
<p>3: eth1: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc pfifo_fast qlen 1000</p>
<p>inet 192.168.4.3/16 brd 192.168.255.255 scope global eth1</p>
<p>inet 192.168.4.1/16 brd 192.168.255.255 scope global secondary eth1:0</p>
<p>[[email&#160;protected] ~]# cat /proc/drbd</p>
<p>version: 8.3.13 (api:88/proto:86-96)</p>
<p>GIT-hash: 83ca112086600faacab2f157bc5a9324f7bd7f77 build by [email&#160;protected], 2012-05-07 11:56:36</p>
<p>1: cs:Connected ro:Primary/Secondary ds:UpToDate/UpToDate C r-----</p>
<p>ns:3 nr:95 dw:98 dr:10 al:1 bm:0 lo:0 pe:0 ua:0 ap:0 ep:1 wo:b oos:0</p>
<p>[[email&#160;protected] ~]# df -h</p>
<p>Filesystem Size Used Avail Use% Mounted on</p>
<p>/dev/sda3 19G 4.7G 14G 26% /</p>
<p>/dev/sda1 190M 18M 163M 10% /boot</p>
<p>tmpfs 60M 0 60M 0% /dev/shm</p>
<p>/dev/drbd1 471M 40M 408M 9% /data</p>
<p>[[email&#160;protected] ~]# mysql -uroot -e "show databases like ‘coral‘;"</p>
<p>+------------------+</p>
<p>| Database (coral) |</p>
<p>+------------------+</p>
<p>| coral |</p>
<p>+------------------+</p>
<p>(3)、模拟master1宕机恢复状态</p>
<p>启动的顺序是：先启动VIP--启动drbd资源--挂载drbd分区--启动mysqld服务，日志如下：</p>
<p>[[email&#160;protected] ~]# /etc/init.d/heartbeat start</p>
<p>[[email&#160;protected] ~]# tailf /var/log/ha-log</p>
<p>heartbeat[27970]: 2013/01/09_17:34:14 info: Version 2 support: no</p>
<p>heartbeat[27970]: 2013/01/09_17:34:14 WARN: Logging daemon is disabled --enabling logging daemon is recommended</p>
<p>heartbeat[27970]: 2013/01/09_17:34:14 info: **************************</p>
<p>heartbeat[27970]: 2013/01/09_17:34:14 info: Configuration validated. Starting heartbeat 2.1.3</p>
<p>heartbeat[27971]: 2013/01/09_17:34:14 info: heartbeat: version 2.1.3</p>
<p>heartbeat[27971]: 2013/01/09_17:34:14 info: Heartbeat generation: 1351554533</p>
<p>heartbeat[27971]: 2013/01/09_17:34:14 info: glib: UDP multicast heartbeat started for group 225.0.0.7 port 694 interface eth2 (ttl=1 loop=0)</p>
<p>heartbeat[27971]: 2013/01/09_17:34:14 info: G_main_add_TriggerHandler: Added signal manual handler</p>
<p>heartbeat[27971]: 2013/01/09_17:34:14 info: G_main_add_TriggerHandler: Added signal manual handler</p>
<p>heartbeat[27971]: 2013/01/09_17:34:14 info: G_main_add_SignalHandler: Added signal handler for signal 17</p>
<p>heartbeat[27971]: 2013/01/09_17:34:14 info: Local status now set to: ‘up‘</p>
<p>heartbeat[27971]: 2013/01/09_17:34:16 info: Link master2:eth2 up.</p>
<p>heartbeat[27971]: 2013/01/09_17:34:16 info: Status update for node master2: status active</p>
<p>harc[27978]: 2013/01/09_17:34:16 info: Running /etc/ha.d/rc.d/status status</p>
<p>heartbeat[27971]: 2013/01/09_17:34:17 info: Comm_now_up(): updating status to active</p>
<p>heartbeat[27971]: 2013/01/09_17:34:17 info: Local status now set to: ‘active‘</p>
<p>heartbeat[27971]: 2013/01/09_17:34:17 info: remote resource transition completed.</p>
<p>heartbeat[27971]: 2013/01/09_17:34:17 info: remote resource transition completed.</p>
<p>heartbeat[27971]: 2013/01/09_17:34:17 info: Local Resource acquisition completed. (none)</p>
<p>heartbeat[27971]: 2013/01/09_17:34:18 info: master2 wants to go standby [foreign]</p>
<p>heartbeat[27971]: 2013/01/09_17:34:20 info: standby: acquire [foreign] resources from master2</p>
<p>heartbeat[27997]: 2013/01/09_17:34:20 info: acquire local HA resources (standby).</p>
<p>ResourceManager[28010]: 2013/01/09_17:34:20 info: Acquiring resource group: master1 IPaddr::192.168.4.1/16/eth1 drbddisk::data Filesystem::/dev/drbd1::/data::ext3 mysqld</p>
<p>IPaddr[28037]: 2013/01/09_17:34:21 INFO: Resource is stopped</p>
<p>ResourceManager[28010]: 2013/01/09_17:34:21 info: Running /etc/ha.d/resource.d/IPaddr 192.168.4.1/16/eth1 start</p>
<p>IPaddr[28135]: 2013/01/09_17:34:21 INFO: Using calculated netmask for 192.168.4.1: 255.255.0.0</p>
<p>IPaddr[28135]: 2013/01/09_17:34:21 INFO: eval ifconfig eth1:0 192.168.4.1 netmask 255.255.0.0 broadcast 192.168.255.255</p>
<p>IPaddr[28106]: 2013/01/09_17:34:21 INFO: Success</p>
<p>ResourceManager[28010]: 2013/01/09_17:34:21 info: Running /etc/ha.d/resource.d/drbddisk data start</p>
<p>Filesystem[28286]: 2013/01/09_17:34:21 INFO: Resource is stopped</p>
<p>ResourceManager[28010]: 2013/01/09_17:34:21 info: Running /etc/ha.d/resource.d/Filesystem /dev/drbd1 /data ext3 start</p>
<p>Filesystem[28367]: 2013/01/09_17:34:21 INFO: Running start for /dev/drbd1 on /data</p>
<p>Filesystem[28356]: 2013/01/09_17:34:21 INFO: Success</p>
<p>ResourceManager[28010]: 2013/01/09_17:34:22 info: Running /etc/init.d/mysqld start</p>
<p>heartbeat[27997]: 2013/01/09_17:34:25 info: local HA resource acquisition completed (standby).</p>
<p>heartbeat[27971]: 2013/01/09_17:34:25 info: Standby resource acquisition done [foreign].</p>
<p>heartbeat[27971]: 2013/01/09_17:34:25 info: Initial resource acquisition complete (auto_failback)</p>
<p>heartbeat[27971]: 2013/01/09_17:34:25 info: remote resource transition completed.</p>
<p>备节点释放资源顺序：停止mysqld服务--卸载drbd1分区--设置drbd为备节点--关闭VIP地址，日志如下：</p>
<p>[[email&#160;protected] ~]# tailf /var/log/ha-log</p>
<p>heartbeat[13209]: 2013/01/23_04:26:53 info: Heartbeat restart on node master1</p>
<p>heartbeat[13209]: 2013/01/23_04:26:53 info: Link master1:eth2 up.</p>
<p>heartbeat[13209]: 2013/01/23_04:26:53 info: Status update for node master1: status init</p>
<p>heartbeat[13209]: 2013/01/23_04:26:53 info: Status update for node master1: status up</p>
<p>harc[16151]: 2013/01/23_04:26:53 info: Running /etc/ha.d/rc.d/status status</p>
<p>harc[16167]: 2013/01/23_04:26:53 info: Running /etc/ha.d/rc.d/status status</p>
<p>heartbeat[13209]: 2013/01/23_04:26:53 info: all clients are now paused</p>
<p>heartbeat[13209]: 2013/01/23_04:26:55 info: Status update for node master1: status active</p>
<p>harc[16183]: 2013/01/23_04:26:55 info: Running /etc/ha.d/rc.d/status status</p>
<p>heartbeat[13209]: 2013/01/23_04:26:55 info: all clients are now resumed</p>
<p>heartbeat[13209]: 2013/01/23_04:26:55 info: remote resource transition completed.</p>
<p>heartbeat[13209]: 2013/01/23_04:26:55 info: master2 wants to go standby [foreign]</p>
<p>heartbeat[13209]: 2013/01/23_04:26:55 info: standby: master1 can take our foreign resources</p>
<p>heartbeat[16199]: 2013/01/23_04:26:55 info: give up foreign HA resources (standby).</p>
<p>ResourceManager[16212]: 2013/01/23_04:26:55 info: Releasing resource group: master1 IPaddr::192.168.4.1/16/eth1 drbddisk::data Filesystem::/dev/drbd1::/data::ext3 mysqld</p>
<p>ResourceManager[16212]: 2013/01/23_04:26:55 info: Running /etc/init.d/mysqld stop</p>
<p>ResourceManager[16212]: 2013/01/23_04:26:57 info: Running /etc/ha.d/resource.d/Filesystem /dev/drbd1 /data ext3 stop</p>
<p>Filesystem[16297]: 2013/01/23_04:26:57 INFO: Running stop for /dev/drbd1 on /data</p>
<p>Filesystem[16297]: 2013/01/23_04:26:57 INFO: Trying to unmount /data</p>
<p>Filesystem[16297]: 2013/01/23_04:26:57 INFO: unmounted /data successfully</p>
<p>Filesystem[16286]: 2013/01/23_04:26:57 INFO: Success</p>
<p>ResourceManager[16212]: 2013/01/23_04:26:57 info: Running /etc/ha.d/resource.d/drbddisk data stop</p>
<p>ResourceManager[16212]: 2013/01/23_04:26:57 info: Running /etc/ha.d/resource.d/IPaddr 192.168.4.1/16/eth1 stop</p>
<p>IPaddr[16445]: 2013/01/23_04:26:58 INFO: ifconfig eth1:0 down</p>
<p>IPaddr[16416]: 2013/01/23_04:26:58 INFO: Success</p>
<p>heartbeat[16199]: 2013/01/23_04:26:58 info: foreign HA resource release completed (standby).</p>
<p>heartbeat[13209]: 2013/01/23_04:26:58 info: Local standby process completed [foreign].</p>
<p>heartbeat[13209]: 2013/01/23_04:27:02 WARN: 1 lost packet(s) for [master1] [15:17]</p>
<p>heartbeat[13209]: 2013/01/23_04:27:02 info: remote resource transition completed.</p>
<p>heartbeat[13209]: 2013/01/23_04:27:02 info: No pkts missing from master1!</p>
<p>heartbeat[13209]: 2013/01/23_04:27:02 info: Other node completed standby takeover of foreign resources.</p>
</td>
</tr>
<tr>
<td>
<br />6、从库同VIP同步</p>
</td>
<td>
<br />(1)、master配置</p>
<p>1)、设置server-id值并开启Binlog参数</p>
<p>[[email&#160;protected] ~]# vim /etc/my.cnf</p>
<p>log-bin=/usr/local/mysql/mysql-bin</p>
<p>server-id = 3</p>
<p>[[email&#160;protected] ~]# /etc/init.d/mysqld restart</p>
<p>#注意：只有master1有重启操作，master2无需重启操作，因为备节点的mysql是未启动状态，备节点只有heartbeat才能启动mysql</p>
<p>2)、授权并建立同步账户rep</p>
<p>[[email&#160;protected] ~]# mysql -uroot -p</p>
<p>mysql&gt; GRANT REPLICATION SLAVE ON *.* TO ‘rep‘@‘192.168.4.%‘ IDENTIFIED BY ‘rep‘;</p>
<p>(2)、slave配置</p>
<p>1)、设置server-id值并关闭binlog设置</p>
<p>[[email&#160;protected] ~]# vim /etc/my.cnf</p>
<p>#log-bin=mysql-bin</p>
<p>server-id = 4</p>
<p>[[email&#160;protected] ~]# /etc/init.d/mysqld restart</p>
<p>#说明：从库无需开启binlog日志功能，除非有需求做级联复制架构或对mysql增量备份操作才开启</p>
<p>2)、配置同步参数</p>
<p>[[email&#160;protected] ~]# mysql -uroot</p>
<p>CHANGE MASTER TO</p>
<p>MASTER_HOST=‘192.168.4.1‘,</p>
<p>MASTER_PORT=3306,</p>
<p>MASTER_USER=‘rep‘,</p>
<p>MASTER_PASSWORD=‘rep‘,</p>
<p>MASTER_LOG_FILE=‘mysql-bin.000001‘,</p>
<p>MASTER_LOG_POS=0;</p>
<p>3)、检查是否主从同步</p>
<p>[[email&#160;protected] ~]# mysql -uroot</p>
<p>mysql&gt; show slave status\G</p>
<p>...</p>
<p>Slave_IO_Running: Yes</p>
<p>Slave_SQL_Running: Yes</p>
<p>...</p>
<p>(3)、模拟高可用宕机切换是否影响从库同步</p>
<p>1)、主从正常状态</p>
<p>[[email&#160;protected] ~]# mysql -uroot</p>
<p>mysql&gt; create database coral1;</p>
<p>Query OK, 1 row affected (0.02 sec)</p>
<p>[[email&#160;protected] ~]# mysql -uroot -e "show slave status\G"|egrep "Slave_IO_Running|Slave_SQL_Running"</p>
<p>Slave_IO_Running: Yes</p>
<p>Slave_SQL_Running: Yes</p>
<p>[[email&#160;protected] ~]# mysql -uroot -e "show databases like ‘coral%‘;"</p>
<p>+-------------------+</p>
<p>| Database (coral%) |</p>
<p>+-------------------+</p>
<p>| coral1 |</p>
<p>+-------------------+</p>
<p>2)、模拟高可用主节点宕机</p>
<p>[[email&#160;protected] ~]# /etc/init.d/heartbeat stop &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; #说明：模拟主节点宕机</p>
<p>[[email&#160;protected] ~]# ip addr|grep eth1</p>
<p>3: eth1: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc pfifo_fast qlen 1000</p>
<p>inet 192.168.4.3/16 brd 192.168.255.255 scope global eth1</p>
<p>inet 192.168.4.1/16 brd 192.168.255.255 scope global secondary eth1:0</p>
<p>[[email&#160;protected] ~]# mysql -uroot</p>
<p>mysql&gt; create database coral2;</p>
<p>Query OK, 1 row affected (0.08 sec) &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;#说明：VIP地址已经漂移到master2上面</p>
<p>[[email&#160;protected] ~]# mysql -uroot -e "show slave status\G"|egrep "Slave_IO_Running|Slave_SQL_Running"</p>
<p>Slave_IO_Running: Yes</p>
<p>Slave_SQL_Running: Yes</p>
<p>[[email&#160;protected] ~]# mysql -uroot -e "show databases like ‘coral%‘"</p>
<p>+-------------------+</p>
<p>| Database (coral%) |</p>
<p>+-------------------+</p>
<p>| coral1 |</p>
<p>| coral2 |</p>
<p>+-------------------+</p>
<p>#注意：高可用主备节点切换过程中，会有一段时间从库才能连接上，大于在60秒内</p>
<p>#说明：此时主从同步是正常的</p>
<p>3)、模拟高可用主节点宕机恢复</p>
<p>[[email&#160;protected] ~]# /etc/init.d/heartbeat start</p>
<p>[[email&#160;protected] ~]# mysql -uroot</p>
<p>mysql&gt; create database coral3;</p>
<p>[[email&#160;protected] ~]# mysql -uroot -e "show slave status\G"|egrep "Slave_IO_Running|Slave_SQL_Running"</p>
<p>Slave_IO_Running: Yes</p>
<p>Slave_SQL_Running: Yes</p>
<p>[[email&#160;protected] ~]# mysql -uroot -e "show databases like ‘coral%‘"</p>
<p>+-------------------+</p>
<p>| Database (coral%) |</p>
<p>+-------------------+</p>
<p>| coral1 |</p>
<p>| coral2 |</p>
<p>| coral3 |</p>
<p>+-------------------+</p>
<p>#说明：高可用主节点故障恢复后也不影响主从库的同步</p>
</td>
</tr>
<tr>
<td>
<br />7、高可用脑裂问题及解决方案</p>
</td>
<td>
<br />(1)、导致裂脑发生的原因</p>
<p>1、高可用服务器之间心跳链路故障，导致无法相互检查心跳</p>
<p>2、高可用服务器上开启了防火墙，阻挡了心跳检测</p>
<p>3、高可用服务器上网卡地址等信息配置不正常，导致发送心跳失败</p>
<p>4、其他服务配置不当等原因，如心跳方式不同，心跳广播冲突，软件BUG等</p>
<p>(2)、防止裂脑一些方案</p>
<p>1、加冗余线路</p>
<p>2、检测到裂脑时，强行关闭心跳检测(远程关闭主节点，控制电源的电路fence)</p>
<p>3、做好脑裂的监控报警</p>
<p>4、报警后，备节点在接管时设置比较长的时间去接管，给运维人员足够的时间去处理(人为处理)</p>
<p>5、启动磁盘锁，正在服务的一方锁住磁盘，裂脑发生时，让对方完全抢不走"共享磁盘资源"</p>
<p>磁盘锁存在的问题：</p>
<p>使用锁磁盘会有死锁的问题，如果占用共享磁盘的一方不主动"解锁"另一方就永远得不到共享磁盘，假如服务器节点突然死机或崩溃，就不可能执行解锁命令，备节点也就无法接管资源和服务了，有人在HA中设计了智能锁，正在提供服务的一方只在发现心跳全部断开时才会启用磁盘锁，平时就不上锁</p>
</td>
</tr>
</tbody>
</table>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 14:05:03 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/drbd/" title="drbd">drbd</a>, <a href="https://www.biecuoliao.com/tag/heartbeat/" title="heartbeat">heartbeat</a>, <a href="https://www.biecuoliao.com/tag/mysql%e9%ab%98%e5%8f%af%e7%94%a8%e6%9e%b6%e6%9e%84/" title="mysql高可用架构">mysql高可用架构</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>15、 Heartbeat+DRBD+MySQL高可用架构方案与实施过程细节的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGakDZ3.html" rel="bookmark">Heartbeat&plus;DRBD&plus;MySQL高可用方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Heartbeat+DRBD+MySQL高可用方案 =============================================================================== 概述: =============================================================================== 方案介绍  1.方案介绍及优缺点 ★方案介绍 本方案采用Heartbeat双机热备软件来保证数据库的高稳定性和连续性,数			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pGo6K3.html" rel="bookmark">Heartbeat&plus;DRBD&plus;MySQL高可用方案【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自Heartbeat+DRBD+MySQL高可用方案 - yayun - 博客园 http://www.cnblogs.com/gomysql/p/3674030.html 1.方案简介 本方案采用Heartbeat双机热备软件来保证数据库的高稳定性和连续性,数据的一致性由DRBD这个工具来保证.默认情况下只有一台mysql在工作,当主mysql服务器出现问题后,系统将自动切换到备机上继续提供服务,当主数据库修复完毕,又将服务切回继续由主mysql提供服务. 2.方案优缺点 优点:安全性高.稳			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e57yJ0.html" rel="bookmark">Heartbeat&plus;Drbd&plus;MySQL高可用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.环境介绍 继续使用之前heartbeat+drbd+nfs的环境,192.168.49.0/24网段用来ssh远程连接,172.16.49.0/24用来做心跳连接,并且也做drbd同步数据使用.因为中间做了好多改变,这里再次给出环境的配置情况. 主机名 角色 IP地址 heartbeat01.contoso.com heartbeat+drbd+mysql(节点1) eth0:192.168.49.133 eth1:172.16.49.133 heartbeat02.contoso.com			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jYRoeM.html" rel="bookmark">centos7&period;5部署heartbeat&plus;DRBD&plus;mysql高可用方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				做双机热备方案需要用到Hearbeat和存储设备(如果没存储设备,可以用DRBD代替,但是最好用存储设备). Heartbeat:如果热备服务器在规定的时间内没有收到主服务器心跳消息那么热备服务器会认为主服务器宕机了,热备服务器就开始工作启动IP.服务等也就是启动故障转移程序.启动故障转移程序的同时并取得主服务器上相关资源服务的控制权,接替主服务器继续不间断的提供服务,从而达到资源及服务高可用性的目的. DRBD(代替存储设备):Distributed Replicated Block Devi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Ypk9XM.html" rel="bookmark">mysql高可用架构方案之二&lpar;keepalived&plus;lvs&plus;读写分离&plus;负载均衡&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql主从复制与lvs+keepalived实现负载高可用 目录 1.前言    4 2.原理    4 2.1.概要介绍    4 2.2.工作原理    4 2.3.实际作用    4 3方案    4 3.1.环境    4 3.2.架构图    5 3.3.设计原理    6 4.相关软件安装    6 4.配置mysql的主从    7 5.通过lvs+keepalived实现负载与热备,并实现读写分离    8 1.前言 最近研究了下高可用的东西,这里总结一下mysql主从复制读			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXoe584.html" rel="bookmark">mysql高可用架构方案之一&lpar;keepalived&plus;主主双活&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Mysql双主双活+keepalived实现高可用 目录 1.前言... 4 2.方案... 4 2.1.环境及软件... 4 2.2.IP规划... 4 2.3.架构图... 4 3.安装设置MYSQL半同步... 5 4.Keepalived实现MYSQL的高可用... 11 1.前言 最近研究了下高可用的东西,这里总结一下mysql主主双活的架构方案,整体上提高服务的高可用性,出现问题也不需要手动切换,提高整体的维护效率.确定改造的话,只需要让他们的程序中使用vip地址就可以,实现起来比较			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vZQXg3.html" rel="bookmark">Heartbeat&plus;Drbd&plus;Mysql高可用（HA）集群架构的部署</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				主机环境 redhat6.5 64位 实验环境 服务端1 ip 172.25.25.111   主机名:server1.example.com          服务端2 ip172.25.25.112    主机名:server2.example.com 安装包   heartbeat-3.0.4-2.el6.x86_64.rpm             heartbeat-devel-3.0.4-2.el6.x86_64.rpm   ldirectord-3.9.5-3.1.x86_64.r			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jlBnE4.html" rel="bookmark">mysql高可用架构谁能提供具体实践实例！！！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql高可用架构目前只查到4中解决方案,如下所示,但是没有具体实践,看到本博客的大神们,能不能给我提供一些实践的实例,谢谢!!!!! 1  Lvs+keeplived+mysql 的方案 单点写入读负载均衡主主同步高可用方案 2 Heartbeat 高可用MySQL 主主同步方案 3 Heartbeat+DRBD+mysql 高可用方案 4 MMM 高可用 mysql 方案			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Oyzd7M.html" rel="bookmark">MySQL数据库的优化（下）MySQL数据库的高可用架构方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL数据库的优化(下)MySQL数据库的高可用架构方案 2011-03-09 08:53 抚琴煮酒 51CTO 字号:T | T 在上一篇MySQL数据库的优化中,我们跟随笔者学习了单机MySQL数据库的优化,今天我们继续跟随笔者学习MySQL优化的集群方案. AD:51CTO 网+首届APP创新评选大赛火热启动——超百万资源等你拿! [51CTO独家特稿]在上一篇MySQL数据库的优化中,我们跟随笔者学习了单机MySQL数据库的优化,今天我们继续跟随笔者学习MySQL优化的集群方案. M			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/VMG9NA3.html" rel="bookmark" class="title">微信小程序组件解读和分析：九、form表单</a>
					<div>
						form表单组件说明: 表单,将组件内的用户输入的&lt;switch/&gt; &lt;input/&gt; &lt;checkbox/&gt; &lt;slider/&gt; &lt;radio/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QWGXE0.html" rel="bookmark" class="title">inux内存映射和共享内存理解和区别</a>
					<div>
						可以看到内存映射中需要的一个参数是int fd(文件的标识符),可见函数是通过fd将文件内容映射到一个内存空间, 我需要创建另一个映射来得到文件内容并统计或修改,这时我创建这另一个映射用的仍是mmap ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5aqw0.html" rel="bookmark" class="title">【一步一个脚印】Tomcat&plus;MySQL为自己的APP打造服务器（2-2）Servlet的使用</a>
					<div>
						在上一篇 [一步一个脚印]Tomcat+MySQL为自己的APP打造服务器(2-1)Servlet 的使用 中我们只是简单的对 Servlet 要做的任务.在服务器中的地位有了一个大概的了解,完成了在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J8KgA0.html" rel="bookmark" class="title">FTP（File Transfer Protocol）是什么？</a>
					<div>
						文件传输协议 FTP(File Transfer Protocol),是文件传输协议的简称.用于Internet上的控制文件的双向传输.同时,它也是一个应用程序(Application).用户可以通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nkY7j3.html" rel="bookmark" class="title">What does enumerable mean&quest;</a>
					<div>
						I was directed to MDN's for..in page when it said, &quot;for..in Iterates over the enumerable proper ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ML288d3.html" rel="bookmark" class="title">MySQL数据库性能优化的技巧和窍门</a>
					<div>
						数据库表表面上存在索引和防错机制,然而一个简单的查询就会耗费很长时间.Web应用程序或许在开发环境中运行良好,但在产品环境中表现同样糟糕.如果你是个数据库管理员,你很有可能已经在某个阶段遇到上述情况. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmAgpYM.html" rel="bookmark" class="title">结伴项目 小学生四则运算</a>
					<div>
						结伴:宫成荣 韩媛媛 需求分析: 为小学生能够出四则运算的题,并且能对其所答的答案进行判断,如答错能显示正确答案. 部分代码: int calculate(int a,int b,int c) { i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRxpO3.html" rel="bookmark" class="title">&lbrack;ExtJS5学习笔记&rsqb;第十三节 Extjs5的Ext&period;each方法学习</a>
					<div>
						本文地址:http://blog.csdn.net/sushengmiyan/article/details/39009555 sencha官方API:http://docs.sencha.com/e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rz5ra3.html" rel="bookmark" class="title">聚合网卡及其练习</a>
					<div>
						聚合网络 1.nmcli connection show 查看当前网卡情况 2.添加两块物理网卡 3.添加聚合逻辑王可并且设置网卡的工作机制 nmcli connection add con-name ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NjRRy4.html" rel="bookmark" class="title">HTML 5入门知识（二）</a>
					<div>
						使用HTML 5结构标签 &lt;article&gt; &lt;article&gt;标签可以在网页中定义独立的内容,包括文章.博客和用户评论等.一个article元素通常有它自己的标题,一般放在一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgloZg0.html" rel="bookmark" class="title">websevice中runtime modeler error&colon; Wrapper class com&period;ws&period;jaxws&period;Add is not found问题的解决办法</a>
					<div>
						查询了网上的资料,有以下解决办法: 1&gt; 先用apt命令将主程序进行编译,然后生成一些java文件2&gt; 升级JDK到版本jdk1.6u17或以后 这两种办法我没有试过,但是试了以下这种方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zZGJM.html" rel="bookmark" class="title">Android实现播放视频</a>
					<div>
						转载:http://www.bdqn.cn/news/201311/12100.shtml 使用VideoView播放视频 VideoView,用于播放一段视频媒体,它继承了SurfaceView,位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eE1rg0.html" rel="bookmark" class="title">恢复忘掉的mysql root密码</a>
					<div>
						1. 干掉mysqld进程  killall mysqld 2. 用下面命令启动     mysqld_safe –skip-grant-tables 3. 复制一个终端,已空密码的方式进入mysql ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YQ1Av0.html" rel="bookmark" class="title">在代码中寻找目标</a>
					<div>
						十几篇博客读下来,让我不得不佩服这些博主的经历以及他们在学习上的努力程度,同时也让我感受到了目前自身的远远不足.这些博主中,有科班出身的,也有非科班出身的,但是不管他们学的是数学,英语,计算机专业,还 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kl1vj3.html" rel="bookmark" class="title">初学算法之uva1599 IdealPath</a>
					<div>
						题目:给一个n个点和m条边的无向图,每条边都涂有一种颜色.求从结点1到结点n的一条路径,使得经过的边数尽量少,在此前提下,经过边的颜色序列的字典序最小.一对结点间可能有多条边,一条边可能连接两个相同结 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDlXRwM.html" rel="bookmark" class="title">函数声明提升机制在浏览器中的bug</a>
					<div>
						JavaScript 解释器中存在一种变量声明被提升(hoisting)的机制,也就是说变量(函数)的声明会被提升到作用域的最前面,即使写代码的时候是写在最后面,也还是会被提升至最前面. 但通过测试, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bLzqe4.html" rel="bookmark" class="title">构建自己的证书颁发服务&lpar;CA&rpar;</a>
					<div>
						本文原创自 http://blog.csdn.net/voipmaker  转载注明出处. 本系列文章分为三篇,主要介绍构建自己的证书颁发服务,生成证书请求,以及通过自己构建的CA给生成的证书请求签名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzX75k3.html" rel="bookmark" class="title">第19周五</a>
					<div>
						晚上去约会,又不能很认真的总结今天,但还是要坚持.今天遇到一个js的问题,两个数字相加变成了字符串相加,不想用函数强转,在网上搜到一个巧方法,将一个数*1即可.晚上调试ws调用问题,工程编译出问题,在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41eYKq4.html" rel="bookmark" class="title">chr &amp;amp&semi;ord</a>
					<div>
						def chr(*args, **kwargs): &quot;&quot;&quot; Return a Unicode string of one character with ordinal i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzDlDq3.html" rel="bookmark" class="title">Git小记</a>
					<div>
						Git简~介 Git是一个分布式版本控制系统,其他的版本控制系统我只用过SVN,但用的时间不长.大家都知道,分布式的好处多多,而且分布式已经包含了集中式的几乎所有功能.Linus创造Git的传奇经历就 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
